#ifdef BOOTCODE
#pragma Code("romcode")
#pragma Cgroup("romgroup")
#pragma Cclass("romclass")
#endif

#include "sanguart.hpp"
#include "stdlib.h"
#include "string.h"

#ifdef PLAT_LINUX
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <stdio.h>
#include <asm/page.h>
#include <asm/io.h>
//***************************************************************
// sys/io.h redefines what's in asm/io.h, and g++ doesn't seem
// to like the sys/io.h distributed with Debian, so we'll use
// asm/io.h
// #include <sys/io.h>
//
// but, now we need a declaration for ioperm() - the following
// include is not portable (i386 only)
// 2000/02/25 - <tmancill@debian.org>
//***************************************************************
#include <sys/perm.h>
#endif

/*
 02/24/98  -  Creating class for G80
*/

//  Sangoma Uart commands.
char   SUCMD_RECEIVE_DATA = 0x01;
char   SUCMD_TRANSMIT_DATA = 0x02;
char   SUCMD_SET_BAUD_RATE = 0x03;
char   SUCMD_READ_CODE_VERSION = 0x10;

unsigned char g_cp_basy_508_top [] =

{'\xf3','\x3e','\x00','\xed','\x39','\x3f','\x3e','\x00',
'\xed','\x39','\xef','\x3e','\x80','\xed','\x39','\x1f',
'\x3e','\x5f','\xed','\x39','\x3e','\x3e','\x00','\xed',
'\x39','\x32','\x3e','\x3c','\xed','\x39','\x36','\x3e',
'\x56','\xed','\x39','\xdf','\x3e','\x01','\xed','\x39',
'\x34','\x3e','\xf0','\xed','\x39','\xee','\x3e','\x00',
'\xed','\x39','\xed','\x3e','\x00','\xed','\x39','\x30',
'\x3e','\x00','\xed','\x39','\x04','\xed','\x39','\x05',
'\xed','\x39','\x01','\x3e','\x10','\xed','\x39','\x00',
'\x3e','\x00','\xed','\x39','\x10','\x3e','\x00','\xed',
'\x39','\x0a','\x3e','\x00','\xed','\x39','\xff','\x3e',
'\x00','\xed','\x39','\xfd','\x3e','\x00','\xed','\x39',
'\x3a','\x3e','\x00','\xed','\x39','\x38','\xed','\x39',
'\x39','\x3e','\x00','\xed','\x47','\xed','\x5e','\x21',
'\x40','\x00','\xed','\x29','\x33','\x06','\x40','\xcb',
'\x38','\x11','\x57','\x02','\x73','\x23','\x72','\x23',
'\x10','\xfa','\x3e','\xc3','\x32','\x66','\x00','\x21',
'\xc1','\x02','\x22','\x67','\x00','\x3e','\xc3','\x32',
'\x00','\x00','\x21','\x6d','\x02','\x22','\x01','\x00',
'\x21','\xd4','\x06','\x22','\x40','\x00','\x21','\xd9',
'\x06','\x22','\x42','\x00','\x21','\x15','\x07','\x22',
'\x44','\x00','\x21','\x1a','\x07','\x22','\x46','\x00',
'\x21','\xde','\x06','\x22','\x48','\x00','\x21','\xe3',
'\x06','\x22','\x4a','\x00','\x21','\xe8','\x06','\x22',
'\x4c','\x00','\x21','\xed','\x06','\x22','\x4e','\x00',
'\x21','\xf2','\x06','\x22','\x50','\x00','\x21','\x0b',
'\x07','\x22','\x70','\x00','\x21','\x10','\x07','\x22',
'\x72','\x00','\x21','\x01','\x07','\x22','\x74','\x00',
'\x21','\x06','\x07','\x22','\x76','\x00','\x21','\xf7',
'\x06','\x22','\x78','\x00','\x21','\xfc','\x06','\x22',
'\x7a','\x00','\x21','\x96','\x06','\x22','\x7c','\x00',
'\x21','\xc7','\x06','\x22','\x7e','\x00','\x3e','\x09',
'\xd3','\xe0','\x3e','\xc0','\xd3','\xe0','\x00','\x00',
'\x00','\x00','\xc3','\x91','\x0a','\x55','\x4e','\x53',
'\x55','\x50','\x50','\x4f','\x52','\x54','\x45','\x44',
'\x20','\x49','\x4e','\x54','\x45','\x52','\x52','\x55',
'\x50','\x54','\x3a','\x20','\x43','\x50','\x55','\x20',
'\x48','\x61','\x6c','\x74','\x65','\x64','\x20','\x2d',
'\x20','\x74','\x79','\x70','\x65','\x20','\x3d','\x20',
'\x54','\x52','\x41','\x50','\x3a','\x20','\x43','\x50',
'\x55','\x20','\x48','\x61','\x6c','\x74','\x65','\x64',
'\x4e','\x4d','\x49','\x3a','\x20','\x43','\x50','\x55',
'\x20','\x48','\x61','\x6c','\x74','\x65','\x64','\xf3',
'\x3e','\x00','\xed','\x39','\x30','\xc5','\x21','\x0d',
'\x02','\x11','\x80','\x00','\x01','\x2b','\x00','\xed',
'\xb0','\xc1','\xeb','\x70','\x76','\xf3','\x3e','\x00',
'\xed','\x39','\x30','\x22','\x90','\x00','\xf5','\xe1',
'\x22','\x92','\x00','\xed','\x43','\x94','\x00','\xed',
'\x53','\x96','\x00','\xdd','\x22','\x98','\x00','\xfd',
'\x22','\x9a','\x00','\xed','\x73','\x9c','\x00','\xe1',
'\x22','\xa0','\x00','\xe1','\x22','\xa2','\x00','\xe1',
'\x22','\xa4','\x00','\xe1','\x22','\xa6','\x00','\xe1',
'\x22','\xa8','\x00','\xe1','\x22','\xaa','\x00','\xe1',
'\x22','\xac','\x00','\xe1','\x22','\xae','\x00','\xed',
'\x38','\x34','\x32','\xb0','\x00','\x21','\x38','\x02',
'\x11','\x80','\x00','\x01','\x10','\x00','\xed','\xb0',
'\x76','\xf3','\x3e','\x00','\xed','\x39','\x30','\x21',
'\x48','\x02','\x11','\x80','\x00','\x01','\x0f','\x00',
'\xed','\xb0','\x76','\x21','\x00','\xe0','\x22','\x36',
'\x24','\xcd','\xf5','\x02','\xcd','\x42','\x06','\xcd',
'\x94','\x03','\x3a','\x38','\x24','\xb7','\xc4','\x1e',
'\x03','\x2a','\x3a','\x24','\x7c','\xb5','\x28','\xef',
'\xcd','\x73','\x03','\x18','\xea','\x21','\x00','\xa0',
'\x22','\x3c','\x24','\x7d','\x32','\x3e','\x24','\x32',
'\x38','\x24','\x32','\x3f','\x24','\x26','\xb0','\x22',
'\x40','\x24','\x22','\x42','\x24','\x65','\x22','\x44',
'\x24','\x26','\xc0','\x22','\x46','\x24','\x22','\x48',
'\x24','\x65','\x22','\x3a','\x24','\xc9','\x2a','\x44',
'\x24','\x11','\x01','\xfc','\x19','\x7c','\xb5','\xc8',
'\x2a','\x3c','\x24','\x5e','\x2a','\x40','\x24','\x73',
'\x2a','\x3c','\x24','\x23','\x22','\x3c','\x24','\x7c',
'\xe6','\xa0','\x67','\x22','\x3c','\x24','\x2a','\x40',
'\x24','\x23','\x22','\x40','\x24','\x7c','\xe6','\xb3',
'\x67','\x22','\x40','\x24','\x3a','\x38','\x24','\x3d',
'\x32','\x38','\x24','\x3a','\x3f','\x24','\xb7','\x28',
'\x0c','\x3a','\x38','\x24','\xfe','\xc8','\x30','\x05',
'\x3e','\x00','\x32','\x3f','\x24','\x2a','\x44','\x24',
'\x23','\x22','\x44','\x24','\x3a','\x38','\x24','\xb7',
'\x20','\xac','\xc9','\x2a','\x48','\x24','\x7e','\x32',
'\x4a','\x24','\xcd','\x5a','\x06','\xc8','\x2a','\x48',
'\x24','\x23','\x22','\x48','\x24','\x7c','\xe6','\xc3',
'\x67','\x22','\x48','\x24','\x2a','\x3a','\x24','\x2b',
'\x22','\x3a','\x24','\xc9','\x2a','\x36','\x24','\x7e',
'\xb7','\xc8','\x2e','\x00','\x7d','\x32','\x5c','\x24',
'\x65','\x22','\x5e','\x24','\x2a','\x36','\x24','\x23',
'\x7e','\x3d','\x28','\x0c','\x3d','\x28','\x0e','\x3d',
'\x28','\x10','\xd6','\x0d','\x28','\x62','\x18','\x7b',
'\xcd','\x54','\x04','\x18','\x7b','\xcd','\xa0','\x04',
'\x18','\x76','\x21','\x58','\x24','\xe5','\x2a','\x36',
'\x24','\x11','\x10','\x00','\x19','\xcd','\x33','\x07',
'\xe1','\xcd','\x45','\x07','\x21','\x58','\x24','\xcd',
'\x33','\x07','\xcd','\x9d','\x07','\x28','\x12','\x21',
'\x58','\x24','\xcd','\x33','\x07','\xcd','\x1f','\x07',
'\x40','\x0d','\x03','\x00','\xcd','\x2f','\x0a','\x28',
'\x07','\x3e','\x01','\x32','\x5c','\x24','\x18','\x40',
'\xcd','\x15','\x05','\xcd','\x72','\x06','\x21','\x04',
'\x00','\x22','\x5e','\x24','\x2a','\x36','\x24','\x11',
'\x10','\x00','\x19','\xe5','\x21','\x58','\x24','\xcd',
'\x33','\x07','\xe1','\xcd','\x45','\x07','\x18','\x20',
'\x21','\x04','\x00','\x22','\x5e','\x24','\xe5','\x2a',
'\x36','\x24','\x11','\x10','\x00','\x19','\xe5','\x21',
'\x00','\x20','\xe5','\xcd','\x58','\x0b','\xd1','\xd1',
'\xd1','\x18','\x05','\x3e','\x0a','\x32','\x5c','\x24',
'\x2a','\x36','\x24','\x23','\x23','\xed','\x5b','\x5e',
'\x24','\x73','\x23','\x72','\x3a','\x5c','\x24','\x2a',
'\x36','\x24','\x11','\x04','\x00','\x19','\x77','\x2a',
'\x36','\x24','\x72','\xc9','\x2a','\x42','\x24','\xeb',
'\x2a','\x40','\x24','\xa7','\xed','\x52','\x20','\x06',
'\x3e','\x01','\x32','\x5c','\x24','\xc9','\x2a','\x42',
'\x24','\x5e','\xd5','\x2a','\x5e','\x24','\x23','\x22',
'\x5e','\x24','\x2b','\xeb','\x2a','\x36','\x24','\x19',
'\x11','\x10','\x00','\x19','\xd1','\x73','\x2a','\x42',
'\x24','\x23','\x22','\x42','\x24','\x7c','\xe6','\xb3',
'\x67','\x22','\x42','\x24','\x2a','\x44','\x24','\x2b',
'\x22','\x44','\x24','\x2a','\x42','\x24','\xeb','\x2a',
'\x40','\x24','\xa7','\xed','\x52','\x20','\xc7','\xc9',
'\x2a','\x36','\x24','\x23','\x23','\x7e','\x23','\xb6',
'\x28','\x0e','\x2a','\x36','\x24','\x23','\x23','\x5e',
'\x23','\x56','\x21','\xff','\xfb','\x19','\x30','\x06',
'\x3e','\x01','\x32','\x5c','\x24','\xc9','\x2a','\x36',
'\x24','\x23','\x23','\x5e','\x23','\x56','\x2a','\x3a',
'\x24','\x19','\x11','\xff','\xfb','\x19','\x30','\x06',
'\x3e','\x02','\x32','\x5c','\x24','\xc9','\x21','\x00',
'\x00','\x22','\x4c','\x24','\x2a','\x4c','\x24','\x23',
'\x22','\x4c','\x24','\x2b','\xeb','\x2a','\x36','\x24',
'\x19','\x11','\x10','\x00','\x19','\x5e','\x2a','\x46',
'\x24','\x73','\x23','\x22','\x46','\x24','\x7c','\xe6',
'\xc3','\x67','\x22','\x46','\x24','\x2a','\x3a','\x24',
'\x23','\x22','\x3a','\x24','\x2a','\x36','\x24','\x23',
'\x23','\x5e','\x23','\x56','\x2a','\x4c','\x24','\xa7',
'\xed','\x52','\x20','\xc8','\xc9','\xcd','\xb3','\x05',
'\x21','\x54','\x24','\xe5','\x2a','\x4e','\x24','\xe5',
'\xcd','\xe8','\x05','\xd1','\xe1','\xcd','\x45','\x07',
'\x21','\x54','\x24','\xcd','\x33','\x07','\x21','\x58',
'\x24','\xcd','\x26','\x07','\xcd','\xdb','\x09','\x28',
'\x76','\x21','\x50','\x24','\xe5','\x21','\x54','\x24',
'\xcd','\x33','\x07','\x21','\x58','\x24','\xcd','\x26',
'\x07','\xcd','\x2f','\x0a','\x28','\x0b','\x2a','\x4e',
'\x24','\x23','\xe5','\xcd','\xe8','\x05','\xd1','\x18',
'\x15','\x2a','\x4e','\x24','\x7c','\xb5','\x28','\x08',
'\x2b','\xe5','\xcd','\xe8','\x05','\xd1','\x18','\x06',
'\x21','\x54','\x24','\xcd','\x33','\x07','\xe1','\xcd',
'\x45','\x07','\x21','\x58','\x24','\xe5','\x21','\x50',
'\x24','\xcd','\x33','\x07','\xcd','\x57','\x07','\xcd',
'\x0b','\x06','\xd1','\xd1','\xcd','\x57','\x07','\x21',
'\x54','\x24','\xcd','\x33','\x07','\xcd','\x57','\x07',
'\xcd','\x0b','\x06','\xd1','\xd1','\xcd','\x65','\x07',
'\xcd','\x11','\x0a','\x28','\x08','\x21','\x54','\x24',
'\xcd','\x33','\x07','\x18','\x06','\x21','\x50','\x24',
'\xcd','\x33','\x07','\xe1','\xcd','\x45','\x07','\xcd',
'\xb3','\x05','\xc9','\x21','\x58','\x24','\xcd','\x33',
'\x07','\x2e','\x05','\xcd','\x59','\x08','\xcd','\x57',
'\x07','\xcd','\x2c','\x07','\x00','\x24','\xf4','\x00',
'\xcd','\x65','\x07','\xcd','\xed','\x08','\xcd','\x54',
'\x0a','\x22','\x4e','\x24','\x11','\xfd','\xff','\x19',
'\x38','\x05','\x21','\x00','\x00','\x18','\x05','\x2a',
'\x4e','\x24','\x2b','\x2b','\x22','\x4e','\x24','\xc9',
'\x21','\x02','\x00','\x39','\x5e','\x23','\x56','\xeb',
'\x23','\x23','\xcd','\x3b','\x0a','\x2e','\x05','\xcd',
'\x59','\x08','\xcd','\x57','\x07','\xcd','\x2c','\x07',
'\x00','\x24','\xf4','\x00','\xcd','\x65','\x07','\xcd',
'\xed','\x08','\xc9','\x21','\x02','\x00','\x39','\xcd',
'\x33','\x07','\x21','\x58','\x24','\xcd','\x26','\x07',
'\xcd','\x26','\x0a','\x28','\x12','\x21','\x02','\x00',
'\x39','\xcd','\x33','\x07','\x21','\x58','\x24','\xcd',
'\x26','\x07','\xcd','\xfa','\x07','\x18','\x10','\x21',
'\x58','\x24','\xcd','\x33','\x07','\x21','\x02','\x00',
'\x39','\xcd','\x26','\x07','\xcd','\xfa','\x07','\x7c',
'\xb5','\xc9','\xf3','\x21','\x06','\x20','\x0e','\xe0',
'\xcd','\x4d','\x06','\xfb','\xc9','\x7e','\xfe','\xff',
'\xc8','\xed','\x79','\x23','\x7e','\xed','\x79','\x23',
'\x18','\xf3','\xf3','\xdb','\xe0','\xfb','\xcb','\x57',
'\x28','\x0b','\x3a','\x4a','\x24','\xd3','\xe1','\x21',
'\x01','\x00','\xf6','\x01','\xc9','\x21','\x00','\x00',
'\xaf','\xc9','\xf3','\x3e','\x0e','\xd3','\xe0','\x3e',
'\x00','\xd3','\xe0','\x2a','\x4e','\x24','\x3e','\x0c',
'\xd3','\xe0','\x7d','\xd3','\xe0','\x3e','\x0d','\xd3',
'\xe0','\x7c','\xd3','\xe0','\x3e','\x0e','\xd3','\xe0',
'\x3e','\x03','\xd3','\xe0','\xfb','\xc9','\x08','\xd9',
'\x3a','\x3f','\x24','\xb7','\x28','\x04','\xdb','\xe1',
'\x18','\x1c','\x21','\x00','\xa0','\x3a','\x3e','\x24',
'\x6f','\x3c','\x32','\x3e','\x24','\xdb','\xe1','\x77',
'\x3a','\x38','\x24','\x3c','\x32','\x38','\x24','\xfe',
'\xfa','\x20','\x03','\x32','\x3f','\x24','\x3e','\x38',
'\xd3','\xe0','\x08','\xd9','\xfb','\xed','\x4d','\x08',
'\x3e','\x30','\xd3','\xe0','\x3e','\x38','\xd3','\xe0',
'\x08','\xfb','\xed','\x4d','\x06','\x40','\xc3','\x57',
'\x02','\x06','\x42','\xc3','\x57','\x02','\x06','\x48',
'\xc3','\x57','\x02','\x06','\x4a','\xc3','\x57','\x02',
'\x06','\x4c','\xc3','\x57','\x02','\x06','\x4e','\xc3',
'\x57','\x02','\x06','\x50','\xc3','\x57','\x02','\x06',
'\xf8','\xc3','\x57','\x02','\x06','\xfa','\xc3','\x57',
'\x02','\x06','\xf4','\xc3','\x57','\x02','\x06','\xf6',
'\xc3','\x57','\x02','\x06','\xf0','\xc3','\x57','\x02',
'\x06','\xf2','\xc3','\x57','\x02','\x06','\xc4','\xc3',
'\x57','\x02','\x06','\xc6','\xc3','\x57','\x02','\xd1',
'\x21','\x04','\x00','\x19','\xe5','\xeb','\x11','\x32',
'\x24','\xc3','\x36','\x07','\xd1','\x21','\x04','\x00',
'\x19','\xe5','\xeb','\x11','\x2a','\x24','\x7e','\x12',
'\x13','\x23','\x7e','\x12','\x13','\x23','\x7e','\x12',
'\x13','\x23','\x7e','\x12','\xc9','\x11','\x2a','\x24',
'\x1a','\x77','\x23','\x13','\x1a','\x77','\x23','\x13',
'\x1a','\x77','\x23','\x13','\x1a','\x77','\xc9','\xd1',
'\x21','\x2d','\x24','\x2a','\x2c','\x24','\xe5','\x2a',
'\x2a','\x24','\xe5','\xeb','\xe9','\xd1','\xe1','\x22',
'\x32','\x24','\xe1','\x22','\x34','\x24','\xeb','\xe9',
'\x2a','\x32','\x24','\xeb','\x2a','\x2a','\x24','\x22',
'\x32','\x24','\xeb','\x22','\x2a','\x24','\x2a','\x34',
'\x24','\xeb','\x2a','\x2c','\x24','\x22','\x34','\x24',
'\xeb','\x22','\x2c','\x24','\xc9','\x21','\x2a','\x24',
'\xaf','\x16','\x04','\x3e','\x00','\x9e','\x77','\x23',
'\x15','\xc2','\x93','\x07','\xc9','\x21','\x2a','\x24',
'\x16','\x04','\x7e','\xb7','\xc2','\xe1','\x09','\x23',
'\x15','\xc2','\xa2','\x07','\xc3','\xd6','\x09','\xaf',
'\x3d','\xc1','\xc9','\xaf','\x3c','\xc1','\xc9','\xc5',
'\x11','\x2d','\x24','\x21','\x35','\x24','\x7e','\xee',
'\x80','\x4f','\x1a','\xee','\x80','\xb9','\x06','\x04',
'\xc3','\xd6','\x07','\xc5','\x11','\x2d','\x24','\x21',
'\x35','\x24','\x06','\x04','\x1a','\xbe','\xda','\xaf',
'\x07','\xc2','\xb3','\x07','\x2b','\x1b','\x05','\xc2',
'\xd4','\x07','\xaf','\xc1','\xc9','\xc5','\x11','\x2a',
'\x24','\x21','\x32','\x24','\xaf','\x06','\x04','\x1a',
'\x8e','\x12','\x23','\x13','\x05','\xc2','\xef','\x07',
'\xc1','\xc9','\xc5','\x11','\x2a','\x24','\x21','\x32',
'\x24','\xaf','\x06','\x04','\x1a','\x9e','\x12','\x23',
'\x13','\x05','\xc2','\x04','\x08','\xc1','\xc9','\xc5',
'\x11','\x2a','\x24','\x21','\x32','\x24','\x06','\x04',
'\x1a','\xa6','\x12','\x23','\x13','\x05','\xc2','\x18',
'\x08','\xc1','\xc9','\xc5','\x11','\x2a','\x24','\x21',
'\x32','\x24','\x06','\x04','\x1a','\xb6','\x12','\x23',
'\x13','\x05','\xc2','\x2c','\x08','\xc1','\xc9','\xc5',
'\x11','\x2a','\x24','\x21','\x32','\x24','\x06','\x04',
'\x1a','\xae','\x12','\x23','\x13','\x05','\xc2','\x40',
'\x08','\xc1','\xc9','\x21','\x2a','\x24','\x16','\x04',
'\x7e','\x2f','\x77','\x23','\x15','\xc2','\x50','\x08',
'\xc9','\x7d','\xe6','\x3f','\xc8','\x2a','\x2a','\x24',
'\xeb','\x2a','\x2c','\x24','\x29','\xeb','\x29','\xeb',
'\xd2','\x6c','\x08','\x2c','\x3d','\xc2','\x64','\x08',
'\x22','\x2c','\x24','\xeb','\x22','\x2a','\x24','\xc9',
'\xaf','\xc3','\x80','\x08','\x3a','\x2d','\x24','\x17',
'\xf5','\x7d','\xe6','\x3f','\xca','\x9b','\x08','\x57',
'\x21','\x2d','\x24','\x1e','\x04','\xf1','\xf5','\x7e',
'\x1f','\x77','\x2b','\x1d','\xc2','\x8f','\x08','\x15',
'\xc2','\x88','\x08','\xf1','\xc9','\x21','\x03','\x00',
'\x19','\x4e','\x79','\xb7','\xf0','\xeb','\xc3','\x90',
'\x07','\xc5','\x11','\x2a','\x24','\xcd','\x9d','\x08',
'\xc5','\x11','\x32','\x24','\xcd','\x9d','\x08','\x79',
'\xc1','\xa9','\xf5','\xcd','\x09','\x09','\xf1','\xc1',
'\xfa','\x8d','\x07','\xc9','\xc5','\x11','\x2a','\x24',
'\xcd','\x9d','\x08','\x79','\xb7','\xf5','\x11','\x32',
'\x24','\xcd','\x9d','\x08','\xcd','\x09','\x09','\x11',
'\x2e','\x24','\x21','\x2a','\x24','\x06','\x04','\x1a',
'\x77','\x13','\x23','\x05','\xc2','\xdf','\x08','\xf1',
'\xc1','\xfa','\x8d','\x07','\xc9','\xc5','\xcd','\x09',
'\x09','\xc1','\xc9','\xc5','\xcd','\x09','\x09','\x11',
'\x2e','\x24','\x21','\x2a','\x24','\x06','\x04','\x1a',
'\x77','\x13','\x23','\x05','\xc2','\xff','\x08','\xc1',
'\xc9','\x06','\x04','\x21','\x2e','\x24','\xaf','\x77',
'\x23','\x05','\xc2','\x0f','\x09','\x3e','\x20','\xf5',
'\x21','\x2a','\x24','\x06','\x08','\xb7','\x7e','\x8f',
'\x77','\x23','\x05','\xc2','\x1e','\x09','\x9f','\xe6',
'\x01','\x4f','\x06','\x04','\x11','\x2e','\x24','\x21',
'\x32','\x24','\xb7','\x1a','\x9e','\x12','\x13','\x23',
'\x05','\xc2','\x33','\x09','\x79','\xde','\x00','\xc2',
'\x4c','\x09','\x21','\x2a','\x24','\x34','\xf1','\x3d',
'\xc2','\x17','\x09','\xc9','\xf1','\x3d','\xca','\x7d',
'\x09','\xf5','\x21','\x2a','\x24','\x06','\x08','\xb7',
'\x7e','\x8f','\x77','\x23','\x05','\xc2','\x58','\x09',
'\x9f','\x4f','\x06','\x04','\x11','\x2e','\x24','\x21',
'\x32','\x24','\xb7','\x1a','\x8e','\x12','\x13','\x23',
'\x05','\xc2','\x6b','\x09','\x79','\xce','\x00','\xc2',
'\x4c','\x09','\xc3','\x42','\x09','\x06','\x04','\x11',
'\x2e','\x24','\x21','\x32','\x24','\xb7','\x1a','\x8e',
'\x12','\x13','\x23','\x05','\xc2','\x86','\x09','\xc9',
'\xc5','\x21','\x2a','\x24','\x06','\x04','\x11','\x2e',
'\x24','\x7e','\x12','\x36','\x00','\x23','\x13','\x05',
'\xc2','\x99','\x09','\x3e','\x20','\xf5','\x21','\x2a',
'\x24','\x06','\x08','\xb7','\x7e','\x8f','\x77','\x23',
'\x05','\xc2','\xac','\x09','\xd2','\xc9','\x09','\x06',
'\x04','\x11','\x2a','\x24','\x21','\x32','\x24','\xb7',
'\x1a','\x8e','\x12','\x13','\x23','\x05','\xc2','\xc0',
'\x09','\xf1','\x3d','\xc2','\xa5','\x09','\xc1','\xc9',
'\xcd','\xb7','\x07','\xca','\xe1','\x09','\x21','\x00',
'\x00','\xaf','\xc9','\xcd','\xb7','\x07','\xca','\xd6',
'\x09','\x21','\x01','\x00','\xaf','\x3c','\xc9','\xcd',
'\xb7','\x07','\xfa','\xe1','\x09','\xc3','\xd6','\x09',
'\xcd','\xb7','\x07','\xfa','\xe1','\x09','\xca','\xe1',
'\x09','\xc3','\xd6','\x09','\xcd','\xb7','\x07','\xfa',
'\xd6','\x09','\xc3','\xe1','\x09','\xcd','\xb7','\x07',
'\xfa','\xd6','\x09','\xca','\xd6','\x09','\xc3','\xe1',
'\x09','\xcd','\xcb','\x07','\xfa','\xe1','\x09','\xc3',
'\xd6','\x09','\xcd','\xcb','\x07','\xfa','\xe1','\x09',
'\xca','\xe1','\x09','\xc3','\xd6','\x09','\xcd','\xcb',
'\x07','\xfa','\xd6','\x09','\xc3','\xe1','\x09','\xcd',
'\xcb','\x07','\xfa','\xd6','\x09','\xca','\xd6','\x09',
'\xc3','\xe1','\x09','\x22','\x2a','\x24','\x21','\x00',
'\x00','\x22','\x2c','\x24','\xc9','\x22','\x2a','\x24',
'\x7c','\xb7','\xf2','\x3e','\x0a','\x21','\xff','\xff',
'\x22','\x2c','\x24','\xc9','\x2a','\x2a','\x24','\xc9',
'\xe1','\xc5','\x5e','\x23','\x56','\x23','\xeb','\x22',
'\x28','\x20','\xeb','\x7b','\xb2','\xca','\x7d','\x0a',
'\x11','\x2a','\x24','\x01','\x04','\x00','\xeb','\x7e',
'\xeb','\xbe','\xc2','\x83','\x0a','\x23','\x13','\x0b',
'\x79','\xb7','\xc2','\x6e','\x0a','\x7e','\x23','\x66',
'\x6f','\xc1','\xe9','\x01','\x06','\x00','\x09','\xeb',
'\x2a','\x28','\x20','\x2b','\xc3','\x5f','\x0a','\x64',
'\x24','\xf3','\x31','\x2a','\x24','\xc3','\xc3','\x0a',
'\x21','\x5b','\x0c','\x11','\x00','\x20','\x01','\x28',
'\x00','\x7c','\xba','\xc2','\xab','\x0a','\x7d','\xbb',
'\xca','\xad','\x0a','\xed','\xb0','\x21','\x28','\x20',
'\x01','\x3c','\x04','\x1e','\x00','\x73','\x23','\x0b',
'\x79','\xb0','\xc2','\xb5','\x0a','\x21','\x64','\x28',
'\x22','\x60','\x24','\xfb','\xc3','\xd3','\x02','\x7c',
'\xa2','\x67','\x7d','\xa3','\x6f','\xb4','\xc9','\x7c',
'\x2f','\x67','\x7d','\x2f','\x6f','\xb4','\xc9','\x7c',
'\xb2','\x67','\x7d','\xb3','\x6f','\xb4','\xc9','\x7c',
'\xaa','\x67','\x7d','\xab','\x6f','\xb4','\xc9','\xe9',
'\xe1','\xc5','\x44','\x4d','\x21','\x00','\x00','\x39',
'\xeb','\x39','\xf9','\xd5','\xdd','\xe5','\xfd','\xe5',
'\x60','\x69','\xcd','\xe7','\x0a','\xfd','\xe1','\xdd',
'\xe1','\xeb','\xe1','\xf9','\xc1','\xeb','\x7c','\xb5',
'\xc9','\xe1','\xc5','\x44','\x4d','\x21','\x00','\x00',
'\x39','\xeb','\x39','\xf9','\xd5','\x21','\x01','\x0b',
'\xe5','\x60','\x69','\xe9','\x7e','\x12','\x23','\x13',
'\x0b','\x78','\xb1','\xc2','\x1c','\x0b','\xc9','\xd1',
'\x21','\x02','\x00','\x39','\xaf','\xc6','\x03','\xea',
'\x36','\x0b','\xdd','\xe5','\xfd','\xe5','\xc5','\xd5',
'\x11','\x22','\x20','\x06','\x06','\x7e','\x12','\x23',
'\x13','\x05','\xc2','\x3d','\x0b','\x21','\x4a','\x0b',
'\xe3','\xe9','\xc1','\xaf','\xc6','\x03','\xea','\x55',
'\x0b','\xfd','\xe1','\xdd','\xe1','\x7c','\xb5','\xc9',
'\xc5','\x21','\x09','\x00','\x39','\x46','\x2b','\x4e',
'\x2b','\x56','\x2b','\x5e','\x2b','\x7e','\x2b','\x6e',
'\x67','\xba','\xda','\x94','\x0b','\xc2','\x78','\x0b',
'\x7d','\xbb','\xda','\x94','\x0b','\xca','\xa8','\x0b',
'\x09','\xeb','\x09','\xaf','\xc6','\x03','\xea','\x88',
'\x0b','\xeb','\x1b','\x2b','\xed','\xb8','\xc1','\xc9',
'\x1b','\x2b','\x1a','\x77','\x0b','\x78','\xb1','\xc2',
'\x88','\x0b','\xc1','\xc9','\xaf','\xc6','\x03','\xea',
'\x9e','\x0b','\xed','\xb0','\xc1','\xc9','\x7e','\x12',
'\x13','\x23','\x0b','\x78','\xb1','\xc2','\x9e','\x0b',
'\xc1','\xc9','\x7c','\xb5','\xca','\xcb','\x0b','\xc3',
'\xbc','\x0b','\x7d','\x93','\xc2','\xbc','\x0b','\x7c',
'\x92','\xca','\xcb','\x0b','\x21','\x00','\x00','\xaf',
'\xc9','\x7d','\x93','\xc2','\xcb','\x0b','\x7c','\x92',
'\xca','\xbc','\x0b','\x21','\x01','\x00','\x7d','\xb4',
'\xc9','\xeb','\x7c','\xaa','\xfa','\xe4','\x0b','\x7d',
'\x93','\x7c','\x9a','\x3f','\x3e','\x00','\xce','\x00',
'\x6f','\x26','\x00','\xc9','\x7a','\x07','\xe6','\x01',
'\x6f','\x26','\x00','\xc9','\xeb','\x7c','\xaa','\xfa',
'\xfe','\x0b','\x7d','\x93','\x7c','\x9a','\x3e','\x00',
'\xce','\x00','\x6f','\x26','\x00','\xc9','\x7c','\x07',
'\xe6','\x01','\x6f','\x26','\x00','\xc9','\x7d','\x2f',
'\x6f','\x7c','\x2f','\x67','\x23','\x7d','\xb4','\xc9',
'\xeb','\x7d','\x93','\x6f','\x7c','\x9a','\x67','\xb5',
'\xc9','\xeb','\xe1','\xc5','\x42','\x4b','\x5e','\x23',
'\x56','\x1b','\x7a','\xb7','\xfa','\x39','\x0c','\x23',
'\x79','\xbe','\xca','\x33','\x0c','\x23','\x23','\x23',
'\xc3','\x21','\x0c','\x23','\x78','\xbe','\xc2','\x2e',
'\x0c','\x23','\x7e','\x23','\x66','\x6f','\xc1','\xe9',
'\xeb','\x7d','\x93','\x7c','\x9a','\x3e','\x00','\x3f',
'\xce','\x00','\x6f','\x26','\x00','\xc9','\xeb','\x7d',
'\x93','\x7c','\x9a','\x3e','\x00','\xce','\x00','\x6f',
'\x26','\x00','\xc9','\x00','\x00','\x00','\x00','\x00',
};

USHORT  g_us_num_mid_zeros = 5024;

unsigned char g_cp_basy_508_bottom [] =
{
'\x31','\x2e','\x30','\x30','\x00','\x00','\x0a','\x00',
'\x0b','\x52','\x02','\x70','\x01','\x10','\x04','\x44',
'\x03','\xc1','\x05','\x68','\x0c','\x18','\x0d','\x00',
'\x0e','\x03','\x09','\x09','\x00','\x30','\x00','\x10',
'\xff','\x00','\x00','\x00','\x00','\x00','\x00','\x00'
};

#ifdef BUILD_SANGOMA_CHANB
unsigned char g_cp_chanb_basy_508_top [] =

{'\xf3','\x3e','\x00','\xed','\x39','\x3f','\x3e','\x00',
'\xed','\x39','\xef','\x3e','\x80','\xed','\x39','\x1f',
'\x3e','\x5f','\xed','\x39','\x3e','\x3e','\x00','\xed',
'\x39','\x32','\x3e','\x3c','\xed','\x39','\x36','\x3e',
'\x56','\xed','\x39','\xdf','\x3e','\x01','\xed','\x39',
'\x34','\x3e','\xf0','\xed','\x39','\xee','\x3e','\x00',
'\xed','\x39','\xed','\x3e','\x00','\xed','\x39','\x30',
'\x3e','\x00','\xed','\x39','\x04','\xed','\x39','\x05',
'\xed','\x39','\x01','\x3e','\x10','\xed','\x39','\x00',
'\x3e','\x00','\xed','\x39','\x10','\x3e','\x00','\xed',
'\x39','\x0a','\x3e','\x00','\xed','\x39','\xff','\x3e',
'\x00','\xed','\x39','\xfd','\x3e','\x00','\xed','\x39',
'\x3a','\x3e','\x00','\xed','\x39','\x38','\xed','\x39',
'\x39','\x3e','\x00','\xed','\x47','\xed','\x5e','\x21',
'\x40','\x00','\xed','\x29','\x33','\x06','\x40','\xcb',
'\x38','\x11','\x57','\x02','\x73','\x23','\x72','\x23',
'\x10','\xfa','\x3e','\xc3','\x32','\x66','\x00','\x21',
'\xc1','\x02','\x22','\x67','\x00','\x3e','\xc3','\x32',
'\x00','\x00','\x21','\x6d','\x02','\x22','\x01','\x00',
'\x21','\x06','\x05','\x22','\x40','\x00','\x21','\x0b',
'\x05','\x22','\x42','\x00','\x21','\x47','\x05','\x22',
'\x44','\x00','\x21','\x4c','\x05','\x22','\x46','\x00',
'\x21','\x10','\x05','\x22','\x48','\x00','\x21','\x15',
'\x05','\x22','\x4a','\x00','\x21','\x1a','\x05','\x22',
'\x4c','\x00','\x21','\x1f','\x05','\x22','\x4e','\x00',
'\x21','\x24','\x05','\x22','\x50','\x00','\x21','\x3d',
'\x05','\x22','\x70','\x00','\x21','\x42','\x05','\x22',
'\x72','\x00','\x21','\xd9','\x04','\x22','\x74','\x00',
'\x21','\xf9','\x04','\x22','\x76','\x00','\x21','\x29',
'\x05','\x22','\x78','\x00','\x21','\x2e','\x05','\x22',
'\x7a','\x00','\x21','\x33','\x05','\x22','\x7c','\x00',
'\x21','\x38','\x05','\x22','\x7e','\x00','\x3e','\x09',
'\xd3','\xe0','\x3e','\xc0','\xd3','\xe0','\x00','\x00',
'\x00','\x00','\xc3','\x53','\x05','\x55','\x4e','\x53',
'\x55','\x50','\x50','\x4f','\x52','\x54','\x45','\x44',
'\x20','\x49','\x4e','\x54','\x45','\x52','\x52','\x55',
'\x50','\x54','\x3a','\x20','\x43','\x50','\x55','\x20',
'\x48','\x61','\x6c','\x74','\x65','\x64','\x20','\x2d',
'\x20','\x74','\x79','\x70','\x65','\x20','\x3d','\x20',
'\x54','\x52','\x41','\x50','\x3a','\x20','\x43','\x50',
'\x55','\x20','\x48','\x61','\x6c','\x74','\x65','\x64',
'\x4e','\x4d','\x49','\x3a','\x20','\x43','\x50','\x55',
'\x20','\x48','\x61','\x6c','\x74','\x65','\x64','\xf3',
'\x3e','\x00','\xed','\x39','\x30','\xc5','\x21','\x0d',
'\x02','\x11','\x80','\x00','\x01','\x2b','\x00','\xed',
'\xb0','\xc1','\xeb','\x70','\x76','\xf3','\x3e','\x00',
'\xed','\x39','\x30','\x22','\x90','\x00','\xf5','\xe1',
'\x22','\x92','\x00','\xed','\x43','\x94','\x00','\xed',
'\x53','\x96','\x00','\xdd','\x22','\x98','\x00','\xfd',
'\x22','\x9a','\x00','\xed','\x73','\x9c','\x00','\xe1',
'\x22','\xa0','\x00','\xe1','\x22','\xa2','\x00','\xe1',
'\x22','\xa4','\x00','\xe1','\x22','\xa6','\x00','\xe1',
'\x22','\xa8','\x00','\xe1','\x22','\xaa','\x00','\xe1',
'\x22','\xac','\x00','\xe1','\x22','\xae','\x00','\xed',
'\x38','\x34','\x32','\xb0','\x00','\x21','\x38','\x02',
'\x11','\x80','\x00','\x01','\x10','\x00','\xed','\xb0',
'\x76','\xf3','\x3e','\x00','\xed','\x39','\x30','\x21',
'\x48','\x02','\x11','\x80','\x00','\x01','\x0f','\x00',
'\xed','\xb0','\x76','\x21','\x00','\xe0','\x22','\x34',
'\x24','\xcd','\xf5','\x02','\xcd','\xa9','\x04','\xcd',
'\x81','\x03','\x3a','\x36','\x24','\xb7','\xc4','\x1b',
'\x03','\x2a','\x38','\x24','\x7c','\xb5','\x28','\xef',
'\xcd','\x60','\x03','\x18','\xea','\x21','\x00','\xa0',
'\x22','\x3a','\x24','\x7d','\x32','\x3c','\x24','\x32',
'\x36','\x24','\x26','\xb0','\x22','\x3e','\x24','\x22',
'\x40','\x24','\x65','\x22','\x42','\x24','\x26','\xc0',
'\x22','\x44','\x24','\x22','\x46','\x24','\x65','\x22',
'\x38','\x24','\xc9','\x2a','\x3a','\x24','\x5e','\x2a',
'\x3e','\x24','\x73','\x2a','\x3a','\x24','\x23','\x22',
'\x3a','\x24','\x7c','\xe6','\xa0','\x67','\x22','\x3a',
'\x24','\x2a','\x42','\x24','\x11','\xff','\xfb','\x19',
'\x38','\x0e','\x2a','\x3e','\x24','\x23','\x22','\x3e',
'\x24','\x7c','\xe6','\xb3','\x67','\x22','\x3e','\x24',
'\x3a','\x36','\x24','\x3d','\x32','\x36','\x24','\x2a',
'\x42','\x24','\x19','\x38','\x07','\x2a','\x42','\x24',
'\x23','\x22','\x42','\x24','\xb7','\x20','\xbc','\xc9',
'\x2a','\x46','\x24','\x7e','\x32','\x48','\x24','\xcd',
'\xc1','\x04','\xc8','\x2a','\x46','\x24','\x23','\x22',
'\x46','\x24','\x7c','\xe6','\xc3','\x67','\x22','\x46',
'\x24','\x2a','\x38','\x24','\x2b','\x22','\x38','\x24',
'\xc9','\x2a','\x34','\x24','\x7e','\xb7','\xc8','\x2e',
'\x00','\x7d','\x32','\x4c','\x24','\x65','\x22','\x4e',
'\x24','\x2a','\x34','\x24','\x23','\x7e','\x3d','\x28',
'\x09','\x3d','\x28','\x0b','\xd6','\x0e','\x28','\x0c',
'\x18','\x25','\xcd','\xe8','\x03','\x18','\x25','\xcd',
'\x34','\x04','\x18','\x20','\x21','\x04','\x00','\x22',
'\x4e','\x24','\xe5','\x2a','\x34','\x24','\x11','\x10',
'\x00','\x19','\xe5','\x21','\x00','\x20','\xe5','\xcd',
'\x1a','\x06','\xd1','\xd1','\xd1','\x18','\x05','\x3e',
'\x0a','\x32','\x4c','\x24','\x2a','\x34','\x24','\x23',
'\x23','\xed','\x5b','\x4e','\x24','\x73','\x23','\x72',
'\x3a','\x4c','\x24','\x2a','\x34','\x24','\x11','\x04',
'\x00','\x19','\x77','\x2a','\x34','\x24','\x72','\xc9',
'\x2a','\x40','\x24','\xeb','\x2a','\x3e','\x24','\xa7',
'\xed','\x52','\x20','\x06','\x3e','\x01','\x32','\x4c',
'\x24','\xc9','\x2a','\x40','\x24','\x5e','\xd5','\x2a',
'\x4e','\x24','\x23','\x22','\x4e','\x24','\x2b','\xeb',
'\x2a','\x34','\x24','\x19','\x11','\x10','\x00','\x19',
'\xd1','\x73','\x2a','\x40','\x24','\x23','\x22','\x40',
'\x24','\x7c','\xe6','\xb3','\x67','\x22','\x40','\x24',
'\x2a','\x42','\x24','\x2b','\x22','\x42','\x24','\x2a',
'\x40','\x24','\xeb','\x2a','\x3e','\x24','\xa7','\xed',
'\x52','\x20','\xc7','\xc9','\x2a','\x34','\x24','\x23',
'\x23','\x7e','\x23','\xb6','\x28','\x0e','\x2a','\x34',
'\x24','\x23','\x23','\x5e','\x23','\x56','\x21','\xff',
'\xfb','\x19','\x30','\x06','\x3e','\x01','\x32','\x4c',
'\x24','\xc9','\x2a','\x34','\x24','\x23','\x23','\x5e',
'\x23','\x56','\x2a','\x38','\x24','\x19','\x11','\xff',
'\xfb','\x19','\x30','\x06','\x3e','\x02','\x32','\x4c',
'\x24','\xc9','\x21','\x00','\x00','\x22','\x4a','\x24',
'\x2a','\x4a','\x24','\x23','\x22','\x4a','\x24','\x2b',
'\xeb','\x2a','\x34','\x24','\x19','\x11','\x10','\x00',
'\x19','\x5e','\x2a','\x44','\x24','\x73','\x23','\x22',
'\x44','\x24','\x7c','\xe6','\xc3','\x67','\x22','\x44',
'\x24','\x2a','\x38','\x24','\x23','\x22','\x38','\x24',
'\x2a','\x34','\x24','\x23','\x23','\x5e','\x23','\x56',
'\x2a','\x4a','\x24','\xa7','\xed','\x52','\x20','\xc8',
'\xc9','\xf3','\x21','\x06','\x20','\x0e','\xe2','\xcd',
'\xb4','\x04','\xfb','\xc9','\x7e','\xfe','\xff','\xc8',
'\xed','\x79','\x23','\x7e','\xed','\x79','\x23','\x18',
'\xf3','\xf3','\xdb','\xe2','\xfb','\xcb','\x57','\x28',
'\x0b','\x3a','\x48','\x24','\xd3','\xe3','\x21','\x01',
'\x00','\xf6','\x01','\xc9','\x21','\x00','\x00','\xaf',
'\xc9','\x08','\xd9','\x21','\x00','\xa0','\x3a','\x3c',
'\x24','\x6f','\x3c','\x32','\x3c','\x24','\xdb','\xe3',
'\x77','\x3a','\x36','\x24','\x3c','\x32','\x36','\x24',
'\x3e','\x38','\xd3','\xe2','\x08','\xd9','\xfb','\xed',
'\x4d','\x08','\x3e','\x30','\xd3','\xe2','\x3e','\x38',
'\xd3','\xe2','\x08','\xfb','\xed','\x4d','\x06','\x40',
'\xc3','\x57','\x02','\x06','\x42','\xc3','\x57','\x02',
'\x06','\x48','\xc3','\x57','\x02','\x06','\x4a','\xc3',
'\x57','\x02','\x06','\x4c','\xc3','\x57','\x02','\x06',
'\x4e','\xc3','\x57','\x02','\x06','\x50','\xc3','\x57',
'\x02','\x06','\xf8','\xc3','\x57','\x02','\x06','\xfa',
'\xc3','\x57','\x02','\x06','\xfc','\xc3','\x57','\x02',
'\x06','\xfe','\xc3','\x57','\x02','\x06','\xf0','\xc3',
'\x57','\x02','\x06','\xf2','\xc3','\x57','\x02','\x06',
'\xc4','\xc3','\x57','\x02','\x06','\xc6','\xc3','\x57',
'\x02','\x54','\x24','\xf3','\x31','\x28','\x24','\xc3',
'\x85','\x05','\x21','\x1d','\x07','\x11','\x00','\x20',
'\x01','\x28','\x00','\x7c','\xba','\xc2','\x6d','\x05',
'\x7d','\xbb','\xca','\x6f','\x05','\xed','\xb0','\x21',
'\x28','\x20','\x01','\x2c','\x04','\x1e','\x00','\x73',
'\x23','\x0b','\x79','\xb0','\xc2','\x77','\x05','\x21',
'\x54','\x28','\x22','\x50','\x24','\xfb','\xc3','\xd3',
'\x02','\x7c','\xa2','\x67','\x7d','\xa3','\x6f','\xb4',
'\xc9','\x7c','\x2f','\x67','\x7d','\x2f','\x6f','\xb4',
'\xc9','\x7c','\xb2','\x67','\x7d','\xb3','\x6f','\xb4',
'\xc9','\x7c','\xaa','\x67','\x7d','\xab','\x6f','\xb4',
'\xc9','\xe9','\xe1','\xc5','\x44','\x4d','\x21','\x00',
'\x00','\x39','\xeb','\x39','\xf9','\xd5','\xdd','\xe5',
'\xfd','\xe5','\x60','\x69','\xcd','\xa9','\x05','\xfd',
'\xe1','\xdd','\xe1','\xeb','\xe1','\xf9','\xc1','\xeb',
'\x7c','\xb5','\xc9','\xe1','\xc5','\x44','\x4d','\x21',
'\x00','\x00','\x39','\xeb','\x39','\xf9','\xd5','\x21',
'\xc3','\x05','\xe5','\x60','\x69','\xe9','\x7e','\x12',
'\x23','\x13','\x0b','\x78','\xb1','\xc2','\xde','\x05',
'\xc9','\xd1','\x21','\x02','\x00','\x39','\xaf','\xc6',
'\x03','\xea','\xf8','\x05','\xdd','\xe5','\xfd','\xe5',
'\xc5','\xd5','\x11','\x22','\x20','\x06','\x06','\x7e',
'\x12','\x23','\x13','\x05','\xc2','\xff','\x05','\x21',
'\x0c','\x06','\xe3','\xe9','\xc1','\xaf','\xc6','\x03',
'\xea','\x17','\x06','\xfd','\xe1','\xdd','\xe1','\x7c',
'\xb5','\xc9','\xc5','\x21','\x09','\x00','\x39','\x46',
'\x2b','\x4e','\x2b','\x56','\x2b','\x5e','\x2b','\x7e',
'\x2b','\x6e','\x67','\xba','\xda','\x56','\x06','\xc2',
'\x3a','\x06','\x7d','\xbb','\xda','\x56','\x06','\xca',
'\x6a','\x06','\x09','\xeb','\x09','\xaf','\xc6','\x03',
'\xea','\x4a','\x06','\xeb','\x1b','\x2b','\xed','\xb8',
'\xc1','\xc9','\x1b','\x2b','\x1a','\x77','\x0b','\x78',
'\xb1','\xc2','\x4a','\x06','\xc1','\xc9','\xaf','\xc6',
'\x03','\xea','\x60','\x06','\xed','\xb0','\xc1','\xc9',
'\x7e','\x12','\x13','\x23','\x0b','\x78','\xb1','\xc2',
'\x60','\x06','\xc1','\xc9','\x7c','\xb5','\xca','\x8d',
'\x06','\xc3','\x7e','\x06','\x7d','\x93','\xc2','\x7e',
'\x06','\x7c','\x92','\xca','\x8d','\x06','\x21','\x00',
'\x00','\xaf','\xc9','\x7d','\x93','\xc2','\x8d','\x06',
'\x7c','\x92','\xca','\x7e','\x06','\x21','\x01','\x00',
'\x7d','\xb4','\xc9','\xeb','\x7c','\xaa','\xfa','\xa6',
'\x06','\x7d','\x93','\x7c','\x9a','\x3f','\x3e','\x00',
'\xce','\x00','\x6f','\x26','\x00','\xc9','\x7a','\x07',
'\xe6','\x01','\x6f','\x26','\x00','\xc9','\xeb','\x7c',
'\xaa','\xfa','\xc0','\x06','\x7d','\x93','\x7c','\x9a',
'\x3e','\x00','\xce','\x00','\x6f','\x26','\x00','\xc9',
'\x7c','\x07','\xe6','\x01','\x6f','\x26','\x00','\xc9',
'\x7d','\x2f','\x6f','\x7c','\x2f','\x67','\x23','\x7d',
'\xb4','\xc9','\xeb','\x7d','\x93','\x6f','\x7c','\x9a',
'\x67','\xb5','\xc9','\xeb','\xe1','\xc5','\x42','\x4b',
'\x5e','\x23','\x56','\x1b','\x7a','\xb7','\xfa','\xfb',
'\x06','\x23','\x79','\xbe','\xca','\xf5','\x06','\x23',
'\x23','\x23','\xc3','\xe3','\x06','\x23','\x78','\xbe',
'\xc2','\xf0','\x06','\x23','\x7e','\x23','\x66','\x6f',
'\xc1','\xe9','\xeb','\x7d','\x93','\x7c','\x9a','\x3e',
'\x00','\x3f','\xce','\x00','\x6f','\x26','\x00','\xc9',
'\xeb','\x7d','\x93','\x7c','\x9a','\x3e','\x00','\xce',
'\x00','\x6f','\x26','\x00','\xc9','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x00','\x00','\x00','\x00','\x00','\x00','\x00','\x00',
'\x31','\x2e','\x30','\x30','\x00','\x00','\x0a','\x00',
'\x0b','\x52','\x02','\x70','\x01','\x10','\x04','\x44',
'\x03','\xc1','\x05','\x68','\x0c','\x32','\x0d','\x00',
'\x0e','\x03','\x09','\x09','\x00','\x30','\x00','\x10',
'\xff','\x00','\x00','\x00','\x00','\x00','\x00','\x00'
};
#endif

cSangVirtUart::cSangVirtUart(ULONG    port_addr,
                             ULONG    mem_addr,
                             USHORT   chan)
{
    c_ul_port_addr = port_addr;
    c_ul_windowphysaddr = mem_addr;
    c_Cp_X25s508ldr = NULL;
    c_b_sang_loaded = FALSE;
    c_sp_mail_box = (s_sang_mail_box *)c_ul_windowphysaddr;
    c_cp_read_buf = new char[1024];
    c_us_data_avail = 0;
    c_us_read_offset = 0;
    c_us_channel = chan;

#ifdef PLAT_LINUX
     int  mem_fd = open("/dev/mem", O_RDWR);
     if (mem_fd < 0)
     {
         cout << "Error: (sanguart) open failed, Linux fd = " << dec << mem_fd << endl;
         return;
     }
     else
     {
         char *l_ul_dprphysaddr = new char[WINDOW_SIZE + (PAGE_SIZE-1)];

         if (l_ul_dprphysaddr == 0)
         {
             cout << "Error: (sanguart) new failed, Linux" <<  endl;
             return;
         }
         else
         {
             if ((unsigned long)l_ul_dprphysaddr % PAGE_SIZE)
             {
                 l_ul_dprphysaddr += PAGE_SIZE -
                      ((unsigned long) l_ul_dprphysaddr % PAGE_SIZE);
             }

             void  *l_vp_windowbase = (void *) mmap(
                          (caddr_t) l_ul_dprphysaddr,
                          (size_t)WINDOW_SIZE, PROT_READ|PROT_WRITE,
                          MAP_SHARED|MAP_FIXED, mem_fd,
                          (off_t)(c_ul_windowphysaddr));

             if (l_vp_windowbase < 0)
             {
                 cout << "Error: (sanguart) mmap failed, Linux"  << endl;
                 return;
             }
             else
             {
                 int   l_perms  = ioperm(c_ul_port_addr, 3, 1);
                 if (l_perms != 0)
                 {
                     cout << "Error: (sanguart) ioperm failed, Linux"  << endl;
                     return;
                 }
                 c_sp_mail_box = (s_sang_mail_box *)l_vp_windowbase;
             }
         }
     }
#endif

}

cSangVirtUart::~cSangVirtUart()
{
    delete c_Cp_X25s508ldr;
}

BOOL   cSangVirtUart::InitUart()
{
    BOOL    l_b_ret_val = FALSE;

    USHORT l_us_code_buf_size = 0;

    if (c_us_channel == 0)
    {
        l_us_code_buf_size = g_us_num_mid_zeros +
              sizeof(g_cp_basy_508_top) +
              sizeof(g_cp_basy_508_bottom);

        UBYTE  *l_code_buf = new UBYTE [l_us_code_buf_size];

        if (l_code_buf != NULL)
        {

    // Build code buffer.  There are alot of zeros in the thing!
            memcpy (l_code_buf, g_cp_basy_508_top, sizeof(g_cp_basy_508_top));
            memset (l_code_buf + sizeof(g_cp_basy_508_top), 0, g_us_num_mid_zeros);
            memcpy (l_code_buf + sizeof(g_cp_basy_508_top) + g_us_num_mid_zeros,
                g_cp_basy_508_bottom, sizeof(g_cp_basy_508_bottom));

            l_b_ret_val = InitUart(l_us_code_buf_size, l_code_buf);
            delete l_code_buf;
        }
    }
#ifdef BUILD_SANGOMA_CHANB
    else if (c_us_channel == 1)
    {
        l_us_code_buf_size = sizeof(g_cp_chanb_basy_508_top);
        l_b_ret_val = InitUart(l_us_code_buf_size, g_cp_chanb_basy_508_top);
    }
#endif

    return l_b_ret_val;
}

BOOL   cSangVirtUart::InitUart(USHORT  l_us_filelength,
                               UBYTE   *l_ucp_codeptr)
{
    BOOL    l_ret_val = FALSE;
    cS508Loader * c_Cp_X25s508ldr = new cS508Loader(c_ul_port_addr,
                   c_ul_windowphysaddr, l_us_filelength, l_ucp_codeptr);
    if (c_Cp_X25s508ldr != NULL)
    {
        USHORT l_download_result = c_Cp_X25s508ldr->DownLoadCode();
        if (l_download_result == 0)
        {
            c_b_sang_loaded = TRUE;
            l_ret_val = TRUE;
        }
        else
        {
            delete c_Cp_X25s508ldr;
            c_Cp_X25s508ldr = NULL;
        }
    }
    return l_ret_val;
}

BOOL   cSangVirtUart::getChar(char   *the_char)
{
    BOOL    l_ret_val = FALSE;
    if (1 == getBlock(the_char, 1))
    {
        l_ret_val = TRUE;
    }
    return l_ret_val;
}

// This code is going to assume that the caller can take
// all of the available data.  This is not a good assumption
// but its a start.  This class will need buffering.
USHORT cSangVirtUart::getBlock(char  *get_buffer, USHORT  get_buf_len)
{
    USHORT   l_us_avail = underflow();
    USHORT   l_us_copied = (l_us_avail >= get_buf_len) ?
                   get_buf_len : l_us_avail;
    memcpy (get_buffer, c_cp_read_buf+c_us_read_offset,
            l_us_copied);
    c_us_read_offset += l_us_copied;
    return l_us_copied;
}

USHORT cSangVirtUart::underflow()
{
    char   l_c_sang_ret;
    if ( (c_us_data_avail-c_us_read_offset) == 0 &&
        TRUE == setCommandValid(SUCMD_RECEIVE_DATA))
    {
        l_c_sang_ret = c_sp_mail_box->return_code;

        // 0x00 - data avail.
        // 0x01 - no data avail.
        switch(l_c_sang_ret)
        {
        case 0x00:
            memcpy (c_cp_read_buf, (char *)(c_sp_mail_box->data),
                    c_sp_mail_box->buffer_length);
            c_us_data_avail = c_sp_mail_box->buffer_length;
            c_us_read_offset = 0;
        break;
        }
    }
    return (c_us_data_avail - c_us_read_offset);
}

BOOL   cSangVirtUart::putChar(char   *the_char)
{
    BOOL    l_ret_val = FALSE;
    if (1 == putBlock(the_char, 1))
    {
        l_ret_val = TRUE;
    }
    return l_ret_val;
}

// This is currently being written to only accept buffers
// of 1024 or less.  This functions could be modified
//  to make multiple calls to the sangoma.
USHORT   cSangVirtUart::putBlock(char  *some_chars, USHORT  len)
{
    USHORT   l_us_ret_val = 0;
    char     l_c_sang_ret;
    if (len <= 1024)
    {
        memcpy ((char *)(c_sp_mail_box->data), some_chars, len);
        c_sp_mail_box->buffer_length = len;
        if (TRUE == setCommandValid(SUCMD_TRANSMIT_DATA))
        {
            l_c_sang_ret = c_sp_mail_box->return_code;

            // 0x01 - length invalid.
            // 0x02 - buffer full.
            switch(l_c_sang_ret)
            {
            case 0x00:
                l_us_ret_val = len;
            break;
            }
        }
    }
    return l_us_ret_val;
}

BOOL   cSangVirtUart::isTxAvail()
{
    // This may need to be fixed but we currently
    // have no equivilant functions provided by Sangoma.
    return TRUE;
}

BOOL   cSangVirtUart::setCommandValid(char  l_c_command)
{
    BOOL   l_b_ret_val = FALSE;
    if (c_sp_mail_box->opp_flag == 0)
    {
        c_sp_mail_box->command = l_c_command;
        c_sp_mail_box->opp_flag = 0x01;
        while (c_sp_mail_box->opp_flag != 0)
        {
            //SWItch();
        }
        l_b_ret_val = TRUE;
    }
    return l_b_ret_val;
}
#ifdef BOOTCODE
#pragma Code()
#endif

